__author__ = 'squirrel'

from model.algo.quaternions import *
from math import *

class MaxRadiusException(Exception):
    pass

class MinRadiusException(Exception):
    pass

def sum_vectors(*args):
    base = [0, 0, 0]
    for arg in args:
        for i in range(3):
            base[i] += arg[i]

    return base

def get_angles(coord, rotation, A, B, C, D, E):

    base_E = (
        E[0] - A[0],
        E[1] - A[1],
        E[2] - A[2],
    )

    rotated_E = rotation.conjugate().v_multiply(base_E)

    new_E = [
        rotated_E[0] - coord[0],
        rotated_E[1] - coord[1],
        rotated_E[2] - coord[2],
    ]

    return centered_get_angles(B, C, D, new_E)

def centered_get_angles(B, C, D, E):
    real_d = sum_vectors(B, C, D)
    alfa = atan2(E[1], E[0]) - atan2(real_d[1], real_d[0])

    beta, gama = get_beta_gama(C, D, [E[0] - B[0], E[1] - B[1], E[2] - B[2]])

    return alfa, beta, gama

def get_beta_gama(C, D, E):

    return 0, 0